#!/bin/sh
# ##############################################################################
#
#    kurs.sh - fetch EURO rate from nbs.rs site and post info on twitter.com/kurs
#    Copyright (C) 2008 Aleksandar Urosevic <urke@users.sourceforge.net>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# *** Version:
#    * 0.1 31.10.2008 [urke] - initial release
#
# *** Crontab schedule:
#
#   # zvanicni kurs EUR za dan u 08:05
#   5 8 * * *       /path/to/kurs.sh
#   # indikativni kurs EUR
#   5 14 * * *      /path/to/kurs.sh ind
#   5 18 * * *      /path/to/kurs.sh ind
#
# ##############################################################################

# uzimam parametar
AKCIJA=$1

function main
{
    # debug var's
    DOBAVI=1
    TEST=1

    # twitter account login info - username:password
    TWLOGIN="username:password"

    # get today date and year to get data from nbs.rs
    DANAS=`date +"%d.%m.%Y"`
    GODINA=`date +"%Y"`

    # do we need to send 'indikativni' or 'today' rate
    case "$AKCIJA" in
        "ind")
            indK;;
        *)
            stdK;;
    esac
}

function indK
{
    # debug
    if [ $DOBAVI == 1 ]; then
        # define var's
        iURL="http://www.nbs.rs/static/nbs_site/gen/latinica/30/kurs/IndikativniKurs.htm"
        
        # fetch data from nbs.rs
        # TODO: put this in variable instead of printing to file
        curl -o /tmp/kurs.i -s $iURL && echo "--> Dobavljen je indikativni kurs za $SUTRA"
    fi

    # parse data from file
    iPREF=`grep '<td class="center">' /tmp/kurs.i | sed -e 's/^.*>//' | sed -e 's/&nbsp;//g'`
    iK=`grep "</b></td>" /tmp/kurs.i | cut -d">" -f2 |sed -e 's/...$//'`

    # format output string
    tmpOUT="$iPREF $iK"
    
    # debug
    if [ $TEST == 1 ]; then
        echo $tmpOUT
    else
        curl -u $TWLOGIN -d status="$tmpOUT" -s http://twitter.com/statuses/update.xml
    fi
} # /indK

function stdK
{
    # debug
    if [ $DOBAVI == 1 ]; then
        # define var's
        kURL="http://www.nbs.rs/internet/latinica/scripts/kl.html"
        kPK="datum=$DANAS&broj=br.&godina=2006&vrsta=1&eksport=csv&:langkl:"
        kS="datum=$DANAS&broj=br.&godina=2006&vrsta=3&eksport=csv&:langkl:"
        
        # fetch data from nbs.rs
        # TODO: put this in variable instead of printing to file
        curl -d $kPK -o /tmp/kurs.pk -s $kURL && echo "--> Dobavljen je prodajni i kupovni kurs za $DANAS"
        curl -d $kS -o /tmp/kurs.s -s $kURL && echo "--> Dobavljen je srednji kurs za $DANAS"
    fi

    # get data from files
    # EUR
    pkEUR=`grep "EUR" /tmp/kurs.pk`
    sEUR=`grep "EUR" /tmp/kurs.s`
    EUR=`echo $pkEUR | cut -d"," -f7`"; "`echo $sEUR | cut -d"," -f7`"; "`echo $pkEUR | cut -d"," -f8`

    # TODO: do we need CHF and USD info for daily rate?
    # CHF
    # pkCHF=`grep "CHF" /tmp/kurs.pk`
    # sCHF=`grep "CHF" /tmp/kurs.s`
    # CHF=`echo $pkCHF | cut -d"," -f7`"; "`echo $sCHF | cut -d"," -f7`"; "`echo $pkCHF | cut -d"," -f8`
    #
    # USD
    # pkUSD=`grep "USD" /tmp/kurs.pk`
    # sUSD=`grep "USD" /tmp/kurs.s`
    # USD=`echo $pkUSD | cut -d"," -f7`"; "`echo $sUSD | cut -d"," -f7`"; "`echo $pkUSD | cut -d"," -f8`

    # get date and list number from file
    kl=`echo $sEUR | cut -d"," -f1`
    klDAT=`echo $sEUR | cut -d"," -f2`

    # format output string
    tmpOUT="Kurs EUR po kursnoj listi NBS br. $kl za $klDAT: $EUR"

    # debug
    if [ $TEST == 1 ]; then
        echo -e $tmpOUT
    else
        curl -u $TWLOGIN -d status="$tmpOUT" -s http://twitter.com/statuses/update.xml && echo "Kurs EUR za $DANAS je poslat!"
    fi
} # /stdK

# initialisation
main

# ############################################################################## OpenMind design #